' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/06 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '͈
    Public m_ExeRegion As New FvRectangle

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        'Rg[̏
        cmbAutoBin.Items.Add("ŒQl")
        cmbAutoBin.Items.Add("ʕ͖@")
        cmbAutoBin.Items.Add("P^C@")
        cmbAutoBin.Items.Add("vVAqXgO")
        cmbAutoBin.Items.Add("ꎟqXgO")
        cmbAutoBin.Items.Add("ŏlEől͈͓")
        cmbAutoBin.Items.Add("Ǐ̈敽ϒl")
        cmbAutoBin.Items.Add("̈臒l")

        cmbAutoBin.SelectedIndex = 0

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_ExeRegion.xs = -1
        m_ExeRegion.xe = -1
        m_ExeRegion.ys = -1
        m_ExeRegion.ye = -1

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                '2lpɎgpC[W̃TCY낦Ă
                AxFvxImage2.ImageType = AxFvxImage1.ImageType
                AxFvxImage2.ImageHeight = AxFvxImage1.ImageHeight
                AxFvxImage2.ImageWidth = AxFvxImage1.ImageWidth

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - 55
            AxFvxDisplayEx1.Size = newSize
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    'J摜捞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

            '2lpɎgpC[W̃TCY낦Ă
            AxFvxImage2.ImageType = AxFvxImage1.ImageType
            AxFvxImage2.ImageHeight = AxFvxImage1.ImageHeight
            AxFvxImage2.ImageWidth = AxFvxImage1.ImageWidth

        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage2.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    '͈͂̐ݒ
    Private Sub btnExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_ExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_ExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_ExeRegion.xe < m_ExeRegion.xs Then
                dblTemp = m_ExeRegion.xs
                m_ExeRegion.xs = m_ExeRegion.xe
                m_ExeRegion.xe = dblTemp
            End If
            If m_ExeRegion.ye < m_ExeRegion.ys Then
                dblTemp = m_ExeRegion.ys
                m_ExeRegion.ys = m_ExeRegion.ye
                m_ExeRegion.ye = dblTemp
            End If
        End If

    End Sub

    '2l@I
    Private Sub cmbAutoBin_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbAutoBin.SelectedIndexChanged

        lblParam1.Text = "Param1"
        lblParam2.Text = "Param2"
        lblParam3.Text = "Param3"
        lblParam4.Text = "Param4"
        lblParam5.Text = "Param5"
        lblParam1.Visible = False
        lblParam2.Visible = False
        lblParam3.Visible = False
        lblParam4.Visible = False
        lblParam5.Visible = False

        txtParam1.Text = "0"
        txtParam2.Text = "0"
        txtParam3.Text = "0"
        txtParam4.Text = "0"
        txtParam5.Text = "0"
        txtParam5.Visible = False
        txtParam1.Visible = False
        txtParam2.Visible = False
        txtParam3.Visible = False
        txtParam4.Visible = False

        Select Case cmbAutoBin.SelectedIndex
            Case 0  'Œ2l
                lblParam1.Text = "臒l"
                lblParam1.Visible = True
                txtParam1.Text = "128"
                txtParam1.Visible = True
            Case 1  'ʕ͖@

            Case 2  'o^C@
                lblParam1.Text = "QlS"
                txtParam1.Text = "50"
                lblParam1.Visible = True
                txtParam1.Visible = True
            Case 3  'vVAqXgO
                lblParam1.Text = "EdgeFactor"
                txtParam1.Text = "50"
                lblParam1.Visible = True
                txtParam1.Visible = True
            Case 4  'ꎟqXgO
                lblParam1.Text = "EdgeFactor"
                txtParam1.Text = "50"
                lblParam1.Visible = True
                txtParam1.Visible = True
            Case 5  'ŏlEől͈͓
                lblParam1.Text = "ŏl"
                txtParam1.Text = "96"
                lblParam2.Text = "ől"
                txtParam2.Text = "192"
                lblParam1.Visible = True
                lblParam2.Visible = True
                txtParam1.Visible = True
                txtParam2.Visible = True
            Case 6  'Ǐ̈敽ϒl
                lblParam1.Text = "Ǐ̈TCY"
                txtParam1.Text = "25"
                lblParam1.Visible = True
                txtParam1.Visible = True
            Case 7  '̈臒l
                lblParam1.Text = ""
                txtParam1.Text = "10"
                lblParam2.Text = "c"
                txtParam2.Text = "10"
                lblParam3.Text = "MatchAve"
                txtParam3.Text = "10"
                lblParam4.Text = "MatchStddev"
                txtParam4.Text = "10"
                lblParam5.Text = "wix"
                txtParam5.Text = "30"

                lblParam1.Visible = True
                lblParam2.Visible = True
                lblParam3.Visible = True
                lblParam4.Visible = True
                lblParam5.Visible = True
                txtParam1.Visible = True
                txtParam2.Visible = True
                txtParam3.Visible = True
                txtParam4.Visible = True
                txtParam5.Visible = True
        End Select

    End Sub

    'NA
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click

        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    Private Function StringToInteger(ByVal strText As String, ByRef intValue As Integer) As Boolean

        StringToInteger = False

        If Integer.TryParse(strText, intValue) = False Then
            MsgBox("lsł", vbExclamation, "G[")
            Exit Function
        End If

        StringToInteger = True

    End Function

    's
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim intErr As Integer
        Dim dblTime As Double

        Dim intParam1 As Integer
        Dim intParam2 As Integer
        Dim intParam3 As Integer
        Dim intParam4 As Integer
        Dim intParam5 As Integer

        If StringToInteger(txtParam1.Text, intParam1) = False Then Exit Sub
        If StringToInteger(txtParam2.Text, intParam2) = False Then Exit Sub
        If StringToInteger(txtParam3.Text, intParam3) = False Then Exit Sub
        If StringToInteger(txtParam4.Text, intParam4) = False Then Exit Sub
        If StringToInteger(txtParam5.Text, intParam5) = False Then Exit Sub

        '͈͂̓Kp
        AxFvxChangeImage1.SetInspectArea(m_ExeRegion)

        'o͑̃C[WNA
        AxFvxImage2.ClearImage()

        Try
            Select Case cmbAutoBin.SelectedIndex
                Case 0  'Œ2l
                    If intParam1 < 0 Or intParam1 > 255 Then
                        MsgBox("臒l 0`255 ̊ԂŎw肵Ă", , "p[^G[")
                        Exit Sub
                    End If
                    AxFvxPerformanceCounter1.StartCount()
                    AxFvxChangeImage1.FixedLevel(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intParam1)
                    AxFvxPerformanceCounter1.StopCount(dblTime)
                Case 1  'ʕ͖@
                    AxFvxPerformanceCounter1.StartCount()
                    AxFvxChangeImage1.Discrimination(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx())
                    AxFvxPerformanceCounter1.StopCount(dblTime)
                Case 2  'o^C@
                    If intParam1 < 0 Or intParam1 > 100 Then
                        MsgBox("2lS 0`100 ̊ԂŎw肵Ă", , "p[^G[")
                        Exit Sub
                    End If
                    AxFvxPerformanceCounter1.StartCount()
                    AxFvxChangeImage1.Ptile(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intParam1)
                    AxFvxPerformanceCounter1.StopCount(dblTime)
                Case 3  'vVAqXgO
                    If intParam1 < 0 Or intParam1 > 100 Then
                        MsgBox("EdgeFactor 0`100 ̊ԂŎw肵Ă", , "p[^G[")
                        Exit Sub
                    End If
                    AxFvxPerformanceCounter1.StartCount()
                    AxFvxChangeImage1.LapHist(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intParam1)
                    AxFvxPerformanceCounter1.StopCount(dblTime)
                Case 4  'ꎟqXgO
                    If intParam1 < 0 Or intParam1 > 100 Then
                        MsgBox("EdgeFactor 0`100 ̊ԂŎw肵Ă", , "p[^G[")
                        Exit Sub
                    End If
                    AxFvxPerformanceCounter1.StartCount()
                    AxFvxChangeImage1.GradHist(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intParam1)
                    AxFvxPerformanceCounter1.StopCount(dblTime)
                Case 5  'ŏlEől͈͓
                    If intParam1 < 0 Or intParam1 > 255 Then
                        MsgBox("ŏl 0`255 ̊ԂŎw肵Ă", , "p[^G[")
                        Exit Sub
                    ElseIf intParam2 < 0 Or intParam2 > 255 Then
                        MsgBox("ől 0`255 ̊ԂŎw肵Ă", , "p[^G[")
                        Exit Sub
                    ElseIf intParam1 > intParam2 Then
                        MsgBox("ŏlőlƂȂ悤w肵Ă", , "p[^G[")
                        Exit Sub
                    End If
                    AxFvxPerformanceCounter1.StartCount()
                    AxFvxChangeImage1.MinMaxLevel(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intParam1, intParam2)
                    AxFvxPerformanceCounter1.StopCount(dblTime)
                Case 6  'Ǐ̈敽ϒl
                    If intParam1 < 3 Or (intParam1 Mod 2) = 0 Then
                        MsgBox("Ǐ̈TCY 3ȏ̊w肵Ă", , "p[^G[")
                        Exit Sub
                    End If
                    AxFvxPerformanceCounter1.StartCount()
                    AxFvxChangeImage1.ShiftAve(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intParam1)
                    AxFvxPerformanceCounter1.StopCount(dblTime)
                Case 7  '̈臒l
                    If intParam1 < 1 Or intParam1 > AxFvxImage1.ImageWidth - 1 Then
                        MsgBox(" 1`" & CStr(AxFvxImage1.ImageWidth - 1) & " ͈̔͂œ͂Ă", , "p[^G[")
                        Exit Sub
                    ElseIf intParam2 < 1 Or intParam2 > AxFvxImage1.ImageHeight - 1 Then
                        MsgBox("c 1`" & CStr(AxFvxImage1.ImageHeight - 1) & " ͈̔͂œ͂Ă", , "p[^G[")
                        Exit Sub
                    ElseIf intParam3 < 0 Or intParam3 > 255 Then
                        MsgBox("MatchAve 0`255 ͈̔͂œ͂Ă", , "p[^G[")
                        Exit Sub
                    ElseIf intParam4 < 0 Or intParam4 > 255 Then
                        MsgBox("MatchStddev 0`255 ͈̔͂œ͂Ă", , "p[^G[")
                        Exit Sub
                    ElseIf intParam5 <= 0 Or intParam5 >= 100 Then
                        MsgBox("wix 1`99 ͈̔͂œ͂Ă", , "p[^G[")
                        Exit Sub
                    End If

                    AxFvxPerformanceCounter1.StartCount()
                    AxFvxChangeImage1.PartDivid(AxFvxImage1.GetOcx(), AxFvxImage2.GetOcx(), intParam1, intParam2, intParam3, intParam4, intParam5)
                    AxFvxPerformanceCounter1.StopCount(dblTime)
            End Select

            AxFvxDisplayEx1.DrawImage(AxFvxImage2.GetOcx())
            txtExecuteTime.Text = VisualBasic.Format(dblTime, "0.00ms")
        Catch ex As Exception
            AxFvxChangeImage1.GetErrReport(intErr)
            MsgBox(GetChangeImageErrMesg(intErr) & " (" & intErr & ")", , "G[")
        End Try

    End Sub

    Public Function GetChangeImageErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetChangeImageErrMesg = "G["
            Case 1501
                GetChangeImageErrMesg = "Ɏs܂B"
            Case 1505
                GetChangeImageErrMesg = "p[^Ⴂ܂B"
            Case 1506
                GetChangeImageErrMesg = "̌^Ⴂ܂B"
            Case 1507
                GetChangeImageErrMesg = "NULLw肳Ă܂B"
            Case 1531
                GetChangeImageErrMesg = "ΏۃC[ŴwTCÝA32̔{łȂ΂Ȃ܂B"
            Case 1532
                GetChangeImageErrMesg = "ΏۃC[Wƌʊi[C[ẂATCYłȂ΂Ȃ܂B"
            Case 1550
                GetChangeImageErrMesg = "C[W̎ނႢ܂B"
            Case 1551
                GetChangeImageErrMesg = "ΏۃC[Wƌʊi[C[WɁÃIuWFNgw肳Ă܂B"
            Case 1552
                GetChangeImageErrMesg = "͈͂̎wɊԈႢ܂B"
            Case Else
                GetChangeImageErrMesg = "sȃG["
        End Select

    End Function

    Private Sub txtParam1_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtParam5.KeyPress, txtParam4.KeyPress, txtParam3.KeyPress, txtParam2.KeyPress, txtParam1.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
